/* SPDX-License-Identifier: GPL-2.0 */
#ifndef _HV_HVHDK_H
#define _HV_HVHDK_H

enum hv_stats_hypervisor_counters {					/* HV_HYPERVISOR_COUNTER */
	HvLogicalProcessors         =  1,
	HvPartitions                =  2,
	HvTotalPages                =  3,
	HvVirtualProcessors         =  4,
	HvMonitoredNotifications    =  5,
	HvModernStandbyEntries      =  6,
	HvPlatformIdleTransitions   =  7,
	HvHypervisorStartupCost     =  8,
	HvIOSpacePages              =  10,
	HvNonEssentialPagesForDump  =  11,
	HvSubsumedPages             =  12,
};

enum hv_stats_partition_counters {					/* HV_PROCESS_COUNTER */
	PartitionVirtualProcessors		= 1,
	PartitionTlbSize			= 3,
	PartitionAddressSpaces			= 4,
	PartitionDepositedPages			= 5,
	PartitionGpaPages			= 6,
	PartitionGpaSpaceModifications		= 7,
	PartitionVirtualTlbFlushEntires		= 8,
	PartitionRecommendedTlbSize		= 9,
	PartitionGpaPages4K			= 10,
	PartitionGpaPages2M			= 11,
	PartitionGpaPages1G			= 12,
	PartitionGpaPages512G			= 13,
	PartitionDevicePages4K			= 14,
	PartitionDevicePages2M			= 15,
	PartitionDevicePages1G			= 16,
	PartitionDevicePages512G		= 17,
	PartitionAttachedDevices		= 18,
	PartitionDeviceInterruptMappings	= 19,
	PartitionIoTlbFlushes			= 20,
	PartitionIoTlbFlushCost			= 21,
	PartitionDeviceInterruptErrors		= 22,
	PartitionDeviceDmaErrors		= 23,
	PartitionDeviceInterruptThrottleEvents	= 24,
	PartitionSkippedTimerTicks		= 25,
	PartitionPartitionId			= 26,
	PartitionNestedTlbSize			= 27,
	PartitionRecommendedNestedTlbSize	= 28,
	PartitionNestedTlbFreeListSize		= 29,
	PartitionNestedTlbTrimmedPages		= 30,
	PartitionPagesShattered			= 31,
	PartitionPagesRecombined		= 32,
	PartitionHwpRequestValue		= 33,
};

enum hv_stats_vp_counters {						/* HV_THREAD_COUNTER */
	VpTotalRunTime                              =  1,
	VpHypervisorRunTime                         =  2,
	VpRemoteNodeRunTime                         =  3,
	VpNormalizedRunTime                         =  4,
	VpIdealCpu                                  =  5,
	VpHypercallsCount                           =  7,
	VpHypercallsTime                            =  8,
	VpPageInvalidationsCount                    =  9,
	VpPageInvalidationsTime                     =  10,
	VpControlRegisterAccessesCount              =  11,
	VpControlRegisterAccessesTime               =  12,
	VpIoInstructionsCount                       =  13,
	VpIoInstructionsTime                        =  14,
	VpHltInstructionsCount                      =  15,
	VpHltInstructionsTime                       =  16,
	VpMwaitInstructionsCount                    =  17,
	VpMwaitInstructionsTime                     =  18,
	VpCpuidInstructionsCount                    =  19,
	VpCpuidInstructionsTime                     =  20,
	VpMsrAccessesCount                          =  21,
	VpMsrAccessesTime                           =  22,
	VpOtherInterceptsCount                      =  23,
	VpOtherInterceptsTime                       =  24,
	VpExternalInterruptsCount                   =  25,
	VpExternalInterruptsTime                    =  26,
	VpPendingInterruptsCount                    =  27,
	VpPendingInterruptsTime                     =  28,
	VpEmulatedInstructionsCount                 =  29,
	VpEmulatedInstructionsTime                  =  30,
	VpDebugRegisterAccessesCount                =  31,
	VpDebugRegisterAccessesTime                 =  32,
	VpPageFaultInterceptsCount                  =  33,
	VpPageFaultInterceptsTime                   =  34,
	VpGuestPageTableMaps                        =  35,
	VpLargePageTlbFills                         =  36,
	VpSmallPageTlbFills                         =  37,
	VpReflectedGuestPageFaults                  =  38,
	VpApicMmioAccesses                          =  39,
	VpIoInterceptMessages                       =  40,
	VpMemoryInterceptMessages                   =  41,
	VpApicEoiAccesses                           =  42,
	VpOtherMessages                             =  43,
	VpPageTableAllocations                      =  44,
	VpLogicalProcessorMigrations                =  45,
	VpAddressSpaceEvictions                     =  46,
	VpAddressSpaceSwitches                      =  47,
	VpAddressDomainFlushes                      =  48,
	VpAddressSpaceFlushes                       =  49,
	VpGlobalGvaRangeFlushes                     =  50,
	VpLocalGvaRangeFlushes                      =  51,
	VpPageTableEvictions                        =  52,
	VpPageTableReclamations                     =  53,
	VpPageTableResets                           =  54,
	VpPageTableValidations                      =  55,
	VpApicTprAccesses                           =  56,
	VpPageTableWriteIntercepts                  =  57,
	VpSyntheticInterrupts                       =  58,
	VpVirtualInterrupts                         =  59,
	VpApicIpisSent                              =  60,
	VpApicSelfIpisSent                          =  61,
	VpGpaSpaceHypercalls                        =  62,
	VpLogicalProcessorHypercalls                =  63,
	VpLongSpinWaitHypercalls                    =  64,
	VpOtherHypercalls                           =  65,
	VpSyntheticInterruptHypercalls              =  66,
	VpVirtualInterruptHypercalls                =  67,
	VpVirtualMmuHypercalls                      =  68,
	VpVirtualProcessorHypercalls                =  69,
	VpHardwareInterrupts                        =  70,
	VpNestedPageFaultInterceptsCount            =  71,
	VpNestedPageFaultInterceptsTime             =  72,
	VpPageScans                                 =  73,
	VpLogicalProcessorDispatches                =  74,
	VpWaitingForCpuTime                         =  75,
	VpExtendedHypercalls                        =  76,
	VpExtendedHypercallInterceptMessages        =  77,
	VpMbecNestedPageTableSwitches               =  78,
	VpOtherReflectedGuestExceptions             =  79,
	VpGlobalIoTlbFlushes                        =  80,
	VpGlobalIoTlbFlushCost                      =  81,
	VpLocalIoTlbFlushes                         =  82,
	VpLocalIoTlbFlushCost                       =  83,
	VpHypercallsForwardedCount                  =  84,
	VpHypercallsForwardingTime                  =  85,
	VpPageInvalidationsForwardedCount           =  86,
	VpPageInvalidationsForwardingTime           =  87,
	VpControlRegisterAccessesForwardedCount     =  88,
	VpControlRegisterAccessesForwardingTime     =  89,
	VpIoInstructionsForwardedCount              =  90,
	VpIoInstructionsForwardingTime              =  91,
	VpHltInstructionsForwardedCount             =  92,
	VpHltInstructionsForwardingTime             =  93,
	VpMwaitInstructionsForwardedCount           =  94,
	VpMwaitInstructionsForwardingTime           =  95,
	VpCpuidInstructionsForwardedCount           =  96,
	VpCpuidInstructionsForwardingTime           =  97,
	VpMsrAccessesForwardedCount                 =  98,
	VpMsrAccessesForwardingTime                 =  99,
	VpOtherInterceptsForwardedCount             =  100,
	VpOtherInterceptsForwardingTime             =  101,
	VpExternalInterruptsForwardedCount          =  102,
	VpExternalInterruptsForwardingTime          =  103,
	VpPendingInterruptsForwardedCount           =  104,
	VpPendingInterruptsForwardingTime           =  105,
	VpEmulatedInstructionsForwardedCount        =  106,
	VpEmulatedInstructionsForwardingTime        =  107,
	VpDebugRegisterAccessesForwardedCount       =  108,
	VpDebugRegisterAccessesForwardingTime       =  109,
	VpPageFaultInterceptsForwardedCount         =  110,
	VpPageFaultInterceptsForwardingTime         =  111,
	VpVmclearEmulationCount                     =  112,
	VpVmclearEmulationTime                      =  113,
	VpVmptrldEmulationCount                     =  114,
	VpVmptrldEmulationTime                      =  115,
	VpVmptrstEmulationCount                     =  116,
	VpVmptrstEmulationTime                      =  117,
	VpVmreadEmulationCount                      =  118,
	VpVmreadEmulationTime                       =  119,
	VpVmwriteEmulationCount                     =  120,
	VpVmwriteEmulationTime                      =  121,
	VpVmxoffEmulationCount                      =  122,
	VpVmxoffEmulationTime                       =  123,
	VpVmxonEmulationCount                       =  124,
	VpVmxonEmulationTime                        =  125,
	VpNestedVMEntriesCount                      =  126,
	VpNestedVMEntriesTime                       =  127,
	VpNestedSLATSoftPageFaultsCount             =  128,
	VpNestedSLATSoftPageFaultsTime              =  129,
	VpNestedSLATHardPageFaultsCount             =  130,
	VpNestedSLATHardPageFaultsTime              =  131,
	VpInvEptAllContextEmulationCount            =  132,
	VpInvEptAllContextEmulationTime             =  133,
	VpInvEptSingleContextEmulationCount         =  134,
	VpInvEptSingleContextEmulationTime          =  135,
	VpInvVpidAllContextEmulationCount           =  136,
	VpInvVpidAllContextEmulationTime            =  137,
	VpInvVpidSingleContextEmulationCount        =  138,
	VpInvVpidSingleContextEmulationTime         =  139,
	VpInvVpidSingleAddressEmulationCount        =  140,
	VpInvVpidSingleAddressEmulationTime         =  141,
	VpNestedTlbPageTableReclamations            =  142,
	VpNestedTlbPageTableEvictions               =  143,
	VpFlushGuestPhysicalAddressSpaceHypercalls  =  144,
	VpFlushGuestPhysicalAddressListHypercalls   =  145,
	VpPostedInterruptNotifications              =  146,
	VpPostedInterruptScans                      =  147,
	VpTotalCoreRunTime                          =  148,
	VpMaximumRunTime                            =  149,
	VpHwpRequestContextSwitches                 =  150,
	VpWaitingForCpuTimeBucket0                  =  151,
	VpWaitingForCpuTimeBucket1                  =  152,
	VpWaitingForCpuTimeBucket2                  =  153,
	VpWaitingForCpuTimeBucket3                  =  154,
	VpWaitingForCpuTimeBucket4                  =  155,
	VpWaitingForCpuTimeBucket5                  =  156,
	VpWaitingForCpuTimeBucket6                  =  157,
	VpVmloadEmulationCount                      =  158,
	VpVmloadEmulationTime                       =  159,
	VpVmsaveEmulationCount                      =  160,
	VpVmsaveEmulationTime                       =  161,
	VpGifInstructionEmulationCount              =  162,
	VpGifInstructionEmulationTime               =  163,
	VpEmulatedErrataSvmInstructions             =  164,
	VpPlaceholder1                              =  165,
	VpPlaceholder2                              =  166,
	VpPlaceholder3                              =  167,
	VpPlaceholder4                              =  168,
	VpPlaceholder5                              =  169,
	VpPlaceholder6                              =  170,
	VpPlaceholder7                              =  171,
	VpPlaceholder8                              =  172,
	VpPlaceholder9                              =  173,
	VpPlaceholder10                             =  174,
	VpSchedulingPriority                        =  175,
	VpRdpmcInstructionsCount                    =  176,
	VpRdpmcInstructionsTime                     =  177,
	VpPerfmonPmuMsrAccessesCount                =  178,
	VpPerfmonLbrMsrAccessesCount                =  179,
	VpPerfmonIptMsrAccessesCount                =  180,
	VpPerfmonInterruptCount                     =  181,
	VpVtl1DispatchCount                         =  182,
	VpVtl2DispatchCount                         =  183,
	VpVtl2DispatchBucket0                       =  184,
	VpVtl2DispatchBucket1                       =  185,
	VpVtl2DispatchBucket2                       =  186,
	VpVtl2DispatchBucket3                       =  187,
	VpVtl2DispatchBucket4                       =  188,
	VpVtl2DispatchBucket5                       =  189,
	VpVtl2DispatchBucket6                       =  190,
	VpVtl1RunTime                               =  191,
	VpVtl2RunTime                               =  192,
	VpIommuHypercalls                           =  193,
	VpCpuGroupHypercalls                        =  194,
	VpVsmHypercalls                             =  195,
	VpEventLogHypercalls                        =  196,
	VpDeviceDomainHypercalls                    =  197,
	VpDepositHypercalls                         =  198,
	VpSvmHypercalls                             =  199,
};

enum hv_stats_lp_counters {							/* HV_CPU_COUNTER */
	LpGlobalTime                    =  1,
	LpTotalRunTime                  =  2,
	LpHypervisorRunTime             =  3,
	LpHardwareInterrupts            =  4,
	LpContextSwitches               =  5,
	LpInterProcessorInterrupts      =  6,
	LpSchedulerInterrupts           =  7,
	LpTimerInterrupts               =  8,
	LpInterProcessorInterruptsSent  =  9,
	LpProcessorHalts                =  10,
	LpMonitorTransitionCost         =  11,
	LpContextSwitchTime             =  12,
	LpC1TransitionsCount            =  13,
	LpC1RunTime                     =  14,
	LpC2TransitionsCount            =  15,
	LpC2RunTime                     =  16,
	LpC3TransitionsCount            =  17,
	LpC3RunTime                     =  18,
	LpRootVpIndex                   =  19,
	LpIdleSequenceNumber            =  20,
	LpGlobalTscCount                =  21,
	LpActiveTscCount                =  22,
	LpIdleAccumulation              =  23,
	LpReferenceCycleCount0          =  24,
	LpActualCycleCount0             =  25,
	LpReferenceCycleCount1          =  26,
	LpActualCycleCount1             =  27,
	LpProximityDomainId             =  28,
	LpPostedInterruptNotifications  =  29,
	LpBranchPredictorFlushes        =  30,
	LpL1DataCacheFlushes            =  31,
	LpImmediateL1DataCacheFlushes   =  32,
	LpMbFlushes                     =  33,
	LpCounterRefreshSequenceNumber  =  34,
	LpCounterRefreshReferenceTime   =  35,
	LpIdleAccumulationSnapshot      =  36,
	LpActiveTscCountSnapshot        =  37,
	LpHwpRequestContextSwitches     =  38,
	LpPlaceholder1                  =  39,
	LpPlaceholder2                  =  40,
	LpPlaceholder3                  =  41,
	LpPlaceholder4                  =  42,
	LpPlaceholder5                  =  43,
	LpPlaceholder6                  =  44,
	LpPlaceholder7                  =  45,
	LpPlaceholder8                  =  46,
	LpPlaceholder9                  =  47,
	LpPlaceholder10                 =  48,
	LpReserveGroupId                =  49,
	LpRunningPriority               =  50,
	LpPerfmonInterruptCount         =  51,
};

#endif /* _HV_HVHDK_H */
